import Data.List;

scx :: Double
scx = 0.0

scy :: Double
scy = 0.0

scz :: Double
scz = -2.0

sw :: Double
sw = 3.0

sh :: Double
sh = 3.0


srwi = 400
srhi = 400

srw = 400.0
srh = 400.0

eps = 0.005
iter = 20

xd = 0.0
yd = 0.0
zd = 1.0

oxx = (sw/srw)*0.5
oyy = (sh/srh)*0.5

ox1 = 0.0
oy1 = oyy

ox2 = (-oxx)
oy2 = (-oyy)

ox3 = oxx
oy3 = (-oyy)

pw = 8

baseCol = [0, 120, 0]

powVec x y z = [r * sin(theta) * cos(phi), r * sin(theta) * sin(phi), r * cos(theta)]
	where	r = tr*tr * tr*tr * tr*tr * tr*tr
		tr = sqrt (x*x + y*y + z*z)
		phi = pw * atan(y/x)
		theta = pw * atan( sqrt(x*x + y*y)/z)

myIterate [x,y,z] [cx,cy,cz] = [zx+cx, zy+cy, zz + cz]
	where	zx = (powVec x y z) !! 0
		zy = (powVec x y z) !! 1
		zz = (powVec x y z) !! 2

isInMandelbulb [x,y,z] = isInMandelbulbRec [x,y,z] [x,y,z] iter

isInMandelbulbRec _ _ 0 = True
isInMandelbulbRec [x,y,z] [cx,cy,cz] it	| x*x + y*y + z*z > 4 = False
					| otherwise = isInMandelbulbRec (myIterate [x,y,z] [cx,cy,cz]) [cx,cy,cz] (it-1)

getOrigin x y = [((x/srw) - 0.5)*sw] ++ [((y/srh) - 0.5)*sh] ++ [scz]

getT x y t	| t > ( abs(scz) + 2) 	= -1
		| isInMandelbulb [ox + t*xd, oy + t*yd, oz + t*zd] = t
		| otherwise = getT x y (t+eps)
	where	ox = (getOrigin x y) !! 0
		oy = (getOrigin x y) !! 1
		oz = (getOrigin x y) !! 2

transformT t	| t <= 0 = 0
		| otherwise = (1-((t - 0.9)/2.3)) * 255.0

colorPixel x y = [c,c,c]
	where 	c = round(transformT (getT x y 0))
		
		
	
calcImgCols = [ colorPixel x y | x <- [0..(srwi-1)], y <- [0..(srhi-1)]]

concatImgStrRec [] = []
concatImgStrRec xs = (show (hh!!0)) ++ " " ++ (show (hh!!1)) ++ " " ++ (show (hh!!2)) ++ " " ++ concatImgStrRec (tail xs)
	where	hh = head xs

imgStr = "P3\n" ++ "400" ++ "\n" ++ "400" ++ "\n" ++ "255\n"
imgPath = "img.ppm"

main = writeFile imgPath (imgStr ++ concatImgStrRec calcImgCols)

